/* Aus PAS 8.6.97: FIRE_EGA (als H oder Standalone !) */  
#include "fire.h"
// #define MTYP unsigned short int
#define MTYP unsigned short int
// round2int(a) ist in typen.h definiert als ((int)rint(a))

void 
fire_step (int first, int xsize, int ysize, EA_PIXEL * destp) 
{
  const mincool = 0, maxcool = 4 - (3 * ALGO), scale_pal=2 - ALGO,  \
    Rand = 8; /* in Prozent (je 1/2 davon L und R) */
    /* maxcool z.B. 1 bei ALGO=1, sonst (ALGO=0) z.B. 4 */
    /* ALGO 1 smooth (alt) ALGO 0 up'n'away (neu) */
  const rand_cool = 10; /* Rand schoener durch more cool ab _ Pixel daneben */
      const fire_col=32;
      const col_inc=(255.0/fire_col);
      int n,c;
      double intens;
  const int drifter[9] = { -1 , -1 , 0 , 0 , 0 , 0 , 0 , 1 , 1 }; 
                         // bevorzugt die Mitte
  
  static int x, y, xy_pos, xy_2, sum;
  static int maxh = 300; /* MTYP beachten */ /* z.B.  ALGO0 maxcool4 -> 300 */
  static int minh = 63;

  static int rand_pix=42;
  static int xm, ym, rfsh;
  static EA_PIXEL * zeig;
  static MTYP * merk;
  static MTYP * merk2; /* merk und merk2 als Byte-Felder reicht oft */
  static EA_PIXEL fire_pal[256];

#ifdef DSP
  static int cooler_maxh; /* siehe Unten!!! */
#endif
  
    if (first == 1)
    {
      rfsh = xsize; 
      xm = xsize; xsize = 42;
#ifdef DSP      
      rfsh <<= 1; /* NEU 11/99 */
      if (fcntl(0 , F_SETFL , O_NONBLOCK)==-1)
         { perror("Error doing fcntl(0 , F_SETFL , O_NONBLOCK): ");
           perror(sys_errlist[errno]); } // 0 ist stdin, 1 stdout, 2 stderr            
#endif      
      ym = ysize; ysize = 42;
      zeig = destp; destp = NULL;
      round2int_inline( rand_pix , Rand * 0.005 * xm ); /* Rand in Prozent */
      
      intens=0;
      for (n=0; n<255; n++) 
      { fire_pal[n]=RGB(n,n,n); }; /* Padding auf 256 Werte */
      for (n=0; n<fire_col; n++) 
      { round2int_inline( c , intens ); 
        intens += col_inc;
        fire_pal[n]=RGB(c,0,0);                           /* s nach r */
        fire_pal[fire_col + n]=RGB(255,c,0);              /* r nach y */
        fire_pal[fire_col + fire_col + n]=RGB(255,255,c); /* y nach w */
      };
      
      merk = (MTYP *)malloc (xm * ym * sizeof(MTYP)); 
      merk2 = (MTYP *)malloc (xm * ym * sizeof(MTYP));
      if ((merk == NULL) || (merk2 == NULL)) err_exit ("Fire: Low Memory!");

      memset( merk , 0 , xm * ym * sizeof(MTYP)); 
      memset( merk2 , 0 , xm * ym * sizeof(MTYP)); 
      return; /* BEI INIT NICHT GLEICH ZYKLUS MACHEN */
    }; /* first war 1 */

  
  if ( ALGO != 1 )  // Neuer Algorithmus
  { for (y = 1; y < (ym - 1); y++)
    { xy_pos = y * xm;
      xy_2 = (xm - 1) - rand_pix;
      for (x = 1; x < (xm - 2); x++)
      { xy_pos++;
        if ( (merk2[xy_pos] < maxcool) || (x < rand_pix) || (x > xy_2) )
        { merk[xy_pos] = 0; }
        else
        { merk[xy_pos] = - rnd ( mincool , maxcool ); 
          /* Verzicht auf 2. rnd stoert hoffentlich nicht das "Design"      */
          /* Verwendung von merk[xy_pos] als Var sollte wegoptimiert werden */
          merk[xy_pos - xm + drifter[rnd(0,8)]] = 
            merk2[xy_pos] + merk[xy_pos];
          merk[xy_pos] += merk2[xy_pos];
          if ( (merk[xy_pos] >= (maxcool << 1)) && 
               ((x < rand_pix + rand_cool) || (x > xy_2 - rand_cool)) )
          { merk[xy_pos] -= maxcool << 1; }; /* schoenerer Rand... */  
        };
      };
    };
  }; /* Ende neuer Algorithmus */

  if ( ALGO == 1 )  // alter Algorithmus
  { memset( merk , 0 , xm * ym * sizeof(MTYP)); 
    for (y = 0; y < (ym - 1); y++)
    { xy_pos = y * xm;
      for (x = 1; x < (xm - 2); x++)
      { xy_pos++;
        sum = (merk2[xy_pos + xm + 1] + merk2[xy_pos + xm - 1]) * 7;
        sum = (sum + merk2[xy_pos] + merk2[xy_pos + xm]) >> 4;
        if (mincool != maxcool) { sum -= rnd ( mincool , maxcool ); }
        else                    { sum -= maxcool; };
        if (sum < 0) { sum = 0; };
        merk[xy_pos] = (MTYP) sum;
      };
    };  
  }; /* Ende alter Algorithmus */

  
  xy_pos = (ym - 2) * xm;
  for (x = 0; x < xm; x++) 
    merk[xy_pos++]=0;
  xy_pos = ((ym - 2) * xm) + rand_pix;
  xy_2 = (xm - 1) - (rand_pix + rand_pix); 
    
  /* ---------------------------------------------------- */
#ifdef DSP
  for (x = 0, cooler_maxh = 0; (x < DSP) && ((sum = getc(stdin)) >= 0); x++)
   {
      sum = (sum>128) ? sum-128 : 128-sum;
      cooler_maxh = (sum > cooler_maxh) ? sum : cooler_maxh; 
    } 
  // cool fx by piping e.g. /dev/dsp (unsigned byte - 0x81+/-...) there...
  // for (x = 0; (x<1999) && (!feof(stdin)); x++, (void)getc(stdin));
  cooler_maxh <<= 2;
#endif 
  /* ---------------------------------------------------- */
  // sonst im folgenden FOR maxh statt cooler_maxh verwenden...
    
  for (x = 0; x < rfsh; x++)
    merk[xy_pos + rnd ( 1 , xy_2 )] =
#ifdef DSP
      (MTYP) cooler_maxh;
#endif
#ifndef DSP 
      (MTYP) rnd ( minh , maxh );
#endif
      
  memcpy(merk2 , merk , xm * ym * sizeof(MTYP)); /* merk2[..]=merk[..] */

  if (ALGO != 1) // nur fuer neuen Algorithmus
    {
      xy_2 = (xm * (ym-1)) - 1; 
      for (xy_pos = 1; xy_pos < xy_2; xy_pos++) /* smooth it out */
      { sum = merk2[xy_pos + 1] + merk2[xy_pos - 1] \
            + merk2[xy_pos]     + merk2[xy_pos + xm];
        merk[xy_pos] = sum >> 2;
      };
    };
    
  xy_pos = 0;
  for (y = 0; y < ym; y++) 
  { for (x = 0; x < xm; x++) 
      { GFX (x, y, zeig) = fire_pal[255 & (byte)(merk[xy_pos]>>scale_pal)]; 
        xy_pos++; 
      };
  };

  if (first == -1)    
  { free (merk); free (merk2); 
    /* kein Clear Screen */
  }; /* das war die ganze End-Routine... */

};


