#include "main.h"

#define FORK 42
// #undef FORK

#ifdef FORK
#define UPDATE show_x(); (void)gettime(); 
#else
#define UPDATE show_x(); oss_fillbuffer(&musikfueller);
#endif

/* evtl. noch mehr, z.B. testen, ob Audio-Nachschub noetig ist, etc.     */
/* gettime wird z.B. als Lebenszeichen an den geforkten Prozess gerufen! */
/* fillbuffer geht nur mit ioctl gut, aber nur 1 Prozess laeuft - das    */
/* ist leichter im Griff zu behalten!                                    */

double POWi(double x, int p) // Aus include/i386/__math.h abgeleitet
{ double r=1.0;              // normal ist pow(double,double) -> double
  if (p < 0) { p = -p; x = 1.0/x; }
  for(;;) 
  { if (p & 1) r *= x;
    if ((p >>= 1) == 0) return r;
    x *= x;
  };
};

int MAIN () 
{ /* MAIN ist ein define fuer main oder _start (falls -nostartfiles) */
char * lasername =  "Laser-Polar-Lissajous";
char * plasmaname = "Plasma, Virt.Pal.Ani.";
char * apfelname =  "Animierter Apfelmann ";
char * starname =   "3d-Starfield         ";
char * firename =   "really nice FIRE fx  ";
char * allname =    "laser, stars and fire";
char * foo =        "its just a checkpoint";
char * muster =     "some simple pattern  ";
char * intername =  "Interferenz von 2xSin";

float modulate, mod_inc;
int count, direction, count2;

randomize; // in typen.h definiert
signalbehandler(); // Aus meinem OSS Modul: nette Fehlermeldungen, Ende
                   // Eventuell um X-Close und Speicherfreigabe erweitern?
                   // Aber am Ende vom Programm wird sowieso alles freigegeben?
init_x ();  // Kein X-Zugriff wird als "falsche Farbtiefe: -1" gemeldet :-)
oss_open(); // Bei einem Fehler gibts halt keinen Sound, sonst Nix.

/* ------------------- */

  testmuster (1, W , H , buffer , 1.0 ); 
  /* alles ausser dem letzten Wert wird nur hier gelesen! */
  init_fps ();

  while ( event_x () ) 
  { 
#ifdef USEDSP  
    testmuster (0, 0 , 0 , NULL , dsp2derive(0 /* stdin */) );
#else
    testmuster (0, 0 , 0 , NULL , 1.0 ); /* eh konstant, aber wg fps ...  */
#endif
    next_fps ();
    UPDATE
  };
  
  show_fps (muster);
  testmuster (-1, 0 , 0 , NULL , 1.0 );

/* ------------------- */

#ifdef FORK
 fprintf(stderr,"OSS Sound wird nun im Fork-Modus aktiviert!\n");
 (void)gettime(); // Zeitbasis starten
 oss_forkplayer(&musikfueller); 
  // -- riskant, wenn 1 Prozess steht,
  // geht die ganze Synchronisation floeten!
#endif
  // alternativ: oss_fillbuffer(void(*player)()), 
  //             oss_send(void * buffer, int length)

/* ------------------- */

  inter_step ( 1 , minimum(W,192) , minimum(H,192) , \
    &GFX( (W-minimum(W,192)) >> 1 , (H-minimum(H,192)) >> 1 , buffer) , 1.0 ); 
  /*  nur hier werden die meisten Werte verwendet  */
  /* Wegen Geschwindigkeit auf 192 x 192 begrenzen */
  init_fps ();

  while ( event_x () ) 
  { inter_step ( 0 , 0 , 0 , NULL , 1.0 );  // Bonuswert ist Zeit-Zoom
    next_fps (); 
    UPDATE 
  }

  show_fps (intername);
  inter_step( -1 , W , H , buffer , 0.0 );

/* ------------------- */

  laser_step ( 1 , W , H , buffer ); /* nur hier werden die Werte verwendet */
  init_fps ();

  while ( event_x () ) 
  { laser_step ( 0 , 0 , 0 , NULL ); 
    next_fps (); 
    UPDATE 
  }

  show_fps (lasername);
  laser_step( -1 , 0 , 0 , NULL );

/* ------------------- */

  plasma_step ( 1 , W , H , buffer , 240 ); 
     /* nur hier werden alle Werte verwendet */
     /* letzter Wert ist HIER eine Prozentangabe fuer den Zufall */
  init_fps ();

  count = 0;
  while ( event_x () ) 
  { 
#ifdef BENCHMARK_PLASMASETUP
    plasma_step ( 1 , W , H , buffer , 240 ); 
#endif
    plasma_step ( 0 , 0 , 0 , NULL , count << 2 ); // letzter Wert ist Phase
    count++;
    count &= 255;
    next_fps (); 
    UPDATE 
  }

  show_fps (plasmaname);
  plasma_step( -1 , W , H , buffer , 0 );

/* ------------------- */

  apfel_step ( 1 , minimum(W,256) , minimum(H,256) , \
    &GFX( (W-minimum(W,256)) >> 1 , (H-minimum(H,256)) >> 1 , buffer) , \
    ZIEL1 );  /* nur hier werden alle Werte verwendet - plus Zielwahl  */
    /* auf 256x256 begrenzen, damit es nicht zu lahm wird */
  init_fps ();

  count = INVSTEPS;
  direction = 1;

  while ( event_x () ) 
  { modulate = POWi( ZOOM * ZOOM , count ); // jeweils doppelte Schritte
    apfel_step ( 0 , 0 , 0 , NULL , modulate );
    // Bonuswert ist hier der Radius des Bildausschnittes
    if (direction>0) { count++; if (count>=   (STEPS>>1)) direction = -1; }
    else             { count--; if (count<=(INVSTEPS>>1)) direction =  1; };
    next_fps ();
    UPDATE 
  }

  show_fps (apfelname);
  apfel_step( -1 , 0 , 0 , NULL , 0.0 );

/* ------------------- */

  fire_step ( 1 , minimum(W,140) , minimum(H,160) , \
    &GFX( (W-minimum(W,140)) >> 1 , (H-minimum(H,160)) >> 1 , buffer)); 
    /* nur hier werden die Werte verwendet */
    /* auf 140x160 begrenzen, damit es nicht zu lahm wird */
  init_fps ();

  while ( event_x () ) 
  { fire_step ( 0 , 128 , 160 , buffer ); 
    next_fps (); 
    UPDATE 
  }

  show_fps (firename);
  fire_step( -1 , 0 , 0 , NULL );

/* ------------------- */

  star_step ( 1 , W , H , buffer ); /* nur hier werden die Werte verwendet */
  init_fps ();

  while ( event_x () ) 
  { star_step ( 0 , W , H , buffer ); 
    next_fps (); 
    UPDATE 
  }

  show_fps (starname);
  star_step( -1 , W , H , buffer );

/* ------------------- */

  
  plasma_step( 1 , W>>2 , H>>1 , &GFX(0        , 0    , buffer) , 240 );
  plasma_step( 0 , 0    , 0    , NULL                 , 0 );
  laser_step ( 1 , W>>2 , H>>1 , &GFX(    W>>2 , 0    , buffer));
  star_step  ( 1 , W>>2 , H>>1 , &GFX(    W>>1 , 0    , buffer));
  plasma_step( 1 , W>>2 , H>>1 , &GFX((3*W)>>2 , 0    , buffer) , 240 );

  fire_step  ( 1 , W>>2 , H>>1 , &GFX(0        , H>>1 , buffer));
  testmuster ( 1 , W>>2 , H>>1 , &GFX(    W>>2 , H>>1 , buffer) , 1.0 );
  inter_step ( 1 , W>>2 , H>>1 , &GFX(    W>>1 , H>>1 , buffer) , 1.0 );
  apfel_step ( 1 , W>>2 , H>>1 , &GFX((3*W)>>2 , H>>1 , buffer) , ZIEL2 );

  init_fps ();
  mod_inc = PI2 / 70; /* Zyklusdauer 70 Frames */   // PI2 = 2*PI, math.h
  modulate = 0.0;
  count = INVSTEPS;
  direction = 1;
  count2 = 0;
  
  while ( event_x () )
  { testmuster ( 0 , 0 , 0 , NULL , 1.42 * (1.33 + sin(2.0 * modulate)) );
    star_step  ( 0 , 0 , 0 , NULL );
    laser_step ( 0 , 0 , 0 , NULL );
    fire_step  ( 0 , 0 , 0 , NULL );
    apfel_step ( 0 , 0 , 0 , NULL , POWi( ZOOM , count ) );
    plasma_step( 0 , 0 , 0 , NULL , count2 );
    // leider sind alle Effekte nicht mehrfach aufrufbar!
    // fire, apfel, inter, testmuster und plasma koennten aber 
    // halbwegs einfach (nicht allzuviele static Variablen)
    // eine Verdoppelungschnittstelle bekommen ???
    inter_step ( 0 , 0 , 0 , NULL , 1.0 * direction );
    modulate += mod_inc;
    if (modulate > PI2) { modulate -= PI2; };
    if (direction>0) { count++; if (count>=   STEPS) direction = -1; }
    else             { count--; if (count<=INVSTEPS) direction =  1; };
    count2 += 7;
    count2 &= 255;
    next_fps ();
    UPDATE
  };

  show_fps (allname);
  fire_step  ( -1 , 0 , 0 , NULL );
  star_step  ( -1 , 0 , 0 , NULL );
  laser_step ( -1 , 0 , 0 , NULL );
  testmuster ( -1 , 0 , 0 , NULL , 1.0 );
  apfel_step ( -1 , 0 , 0 , NULL , 0.0 );
  plasma_step( -1 , 0 , 0 , NULL , 0 );
  inter_step ( -1 , 0 , 0 , NULL , 0.0 );
    
/* ------------------- */

  oss_close ();
  close_x ();
  
  show_fps (foo);
  exit (0);
  
}
