#include "plasma.h"

/* 1/2000 Verbesserung von plasma_x in FAKE-Demo-Source rekonstruiert!? */
/* -->  Trick ist, vorhandene Werte moeglichst oft zu verwenden...  <-- */

// skala, skaldisp zur Zeit "toter Code" !!!

#define P_FP double /* statt real 1/00 */

static int iter=9;
static int size=512; // 2^iter bzw. 2^(iter+1)

static int * virtual;
static EA_PIXEL * ziel;
static EA_PIXEL rainbow[256];

static P_FP plasmamodulator=42;

__inline__ int Xrnd(int n, int o, int w) 
// Schnitt aus n und o, plus Zufall/2^w
{ int rnd_mitte;
  float res  = (0.01 * plasmamodulator) * rnd( -(size>>w) , size>>w );;
  round2int_inline(rnd_mitte, res);
  rnd_mitte += (n+o) >> 1;
  return CLIP2BYTE(rnd_mitte);
};

void teile(int x1, int y1, int x3, int y3, \
           EA_PIXEL a, EA_PIXEL c, EA_PIXEL g, EA_PIXEL i, int q)
{ int x2,y2;
  EA_PIXEL b,d,e,f,h;
  if (q==iter) return;

  x2 = (1+x1+x3) >> 1; 
  y2 = (1+y1+y3) >> 1;
  b = virtual[x2 + (size * y1)];
  if (!b) { b = Xrnd(a,c,q); virtual[x2 + (size * y1)] = b; };
  d = virtual[x1 + (size * y2)];
  if (!d) { d = Xrnd(a,g,q); virtual[x1 + (size * y2)] = d; };
  f = virtual[x3 + (size * y2)];
  if (!f) { f = Xrnd(c,i,q); virtual[x3 + (size * y2)] = f; };
  h = virtual[x2 + (size * y3)];
  if (!h) { h = Xrnd(g,i,q); virtual[x2 + (size * y3)] = h; };
  e = virtual[x2 + (size * y2)];
  if (!e) { e = Xrnd((b+h) >> 1,(d+f) >> 1,q); 
            virtual[x2 + (size * y2)] = e; };
  teile(x1,y1,x2,y2,a,b,d,e,q+1); 
  teile(x2,y1,x3,y2,b,c,e,f,q+1);
  teile(x1,y2,x2,y3,d,e,g,h,q+1); 
  teile(x2,y2,x3,y3,e,f,h,i,q+1);
};


/*
void virt2gfx(int phase) // Virtuellen 8bpp Schirm anzeigen - ZEITKRITISCH
{ register int x;
  register int y;
  register int y2;
  for (y=0, y2=0; y<size; y++)
  { for (x=0; x<size; x++, y2++)
    { GFX(x , y , ziel) = 
       rainbow[ 255 & ( phase + virtual[y2] ) ];
    };
  }; // Das war der entscheidende Schritt zur virtuellen Palettenanimation!
};   // NICHT inline, da sonst nicht genug reg-vars verfuegbar sind!
*/   // wie geht "__no_inline__" ? Also ausgelagert in plasma_two.o *8-]

void plasma_step( int first, int xsize, int ysize, EA_PIXEL * destp, \
 int phase )
{

  if (first == 1)
  { EA_PIXEL s,t,u,v;
    int p, pround;
    P_FP pfloat; 
    P_FP thing = 255.0/86.0;
    ziel = destp;
    while (size > minimum(xsize,ysize)) { size >>= 1; iter--; };
    if (!size) { size = 1; iter=1; };
    virtual = (int *)malloc(size * size * sizeof(int));
    /* wenn das 0 ist, gibts ein Problem! */
    /* Ausweg waere, ohne Pal-Ani nur 1 Schnappschuss zu malen ... */
    if (virtual==NULL) { err_exit("Plasma: Low Memory!"); };
       /* ... aber der Ausweg ist noch nicht implementiert */
    memset( (void *)virtual ,'\0' , size * size * sizeof(int) );     

    plasmamodulator = phase; // int -> float

    for (p=0,  pfloat=0,  pround=0; \
         p<=86; \
         p++,  pfloat+=thing)
    { round2int_inline( pround , pfloat );
      rainbow[p          ] = RGB(0 , pround , 256-pround);
      rainbow[p + 85     ] = RGB(pround , 256-pround , 0);
      rainbow[p + 85 + 85] = RGB(256-pround , 0 , pround); 
    };
    rainbow[255] = RGB( 32 , 32 , 255 );
    s = virtual[   0     +        0       ] = STARTRND ? rnd(0,255) :   1;
    t = virtual[(size-1) +        0       ] = STARTRND ? rnd(0,255) : 127;
    u = virtual[   0     + ((size-1)*size)] = STARTRND ? rnd(0,255) : 127;
    v = virtual[(size-1) + ((size-1)*size)] = STARTRND ? rnd(0,255) :   1;
    teile(0,0,size-1,size-1,s,t,u,v,0); // REKURSIV
    return; /* genug fuer den Anfang! */
  }; 

  if (first == -1) 
  { free(virtual);  
    /* das reicht fuer den Anfang, Clearscreen ist sogar eher schlecht */
    return;
  };

  if (first == 0)
  { 
    __asm__("movl %eax,%eax");
    virt2gfx(phase, size, virtual, ziel, &rainbow[0]); 
    // virtuelle Palettenanimation! - ZEITKRITISCH
    __asm__("movl %eax,%eax");
  };

  return;
};

/* ----------------------------------------------------------------------- */

void skala()
{ int sx,sy, sh, nn;
  sh = 4242; nn = 4242;
  for (sx=206; sx<214; sx++)
  { GFX(sx,0,ziel)=rainbow[1]; 
    GFX(sx,sh,ziel)=rainbow[255]; 
    if (sx<210)
    { for (sy=0; sy<nn; sy++) 
      { GFX(sx, round2int(sy*sh/nn), ziel) = rainbow[1+round2int(sy*254/nn)];
      };
    };
  };
  for (sy=0; sy<sh; sy++)
  { GFX(205,sy,ziel) = rainbow[1+round2int(sy*254/sh)]; 
    GFX(215,sy,ziel) = rainbow[1+round2int(sy*254/sh)];
  };
};

void scaldisp(int sd)
{ int sx, sy, sh, r1, nn;
  sh = 4242; r1 = 4242; nn = 4242;
  for (sy=0; sy<round2int((sd-r1)*sh/nn); sy++)
  { for (sx=205; sx<215; sx++)
    { GFX(sx,sy,ziel) = 1+rainbow[round2int(sy*254/sh)]; };
  };
};

/* ----------------------------------------------------------------------- */
