#include "plasma.h"

#ifdef TUNED_ASSUMPTION
// Annahme: nebeneinanderliegende Pixel sind im Speicher nacheinander!

void virt2gfx(int phase, int size, int * virtual, \
 EA_PIXEL * ziel, EA_PIXEL * rainbow )
// Virtuellen 8bpp Schirm anzeigen - ZEITKRITISCH
{
if ( (sizeof(EA_PIXEL)==2) && (sizeof(int)==4) )
{ register int y;
  for (y=0; y<size; y++)
  { __asm__ __volatile__
    ("cld
      pushl %%eax
      pushl %%edi
      .align 16
      1:
      lodsl                     # read *virtual, virtual++
      addl %%edx,%%eax          # add phase
      movzbl %%al,%%eax         # mask to 8 bit - type A
      # andl $255,%%eax         # mask to 8 bit - type B
      # movzbl ist besser, da der Loop dann in 16 Byte passt.
      # Zumindest auf Cx6x68... andere CPUs haben evtl. AL/EAX-Clash-Penalties
      movw (%%ebx,%%eax,2),%%ax # read rainbow[...]
      stosw                     # write *gfxp, gfxp++
      cmpl %%ecx,%%edi          # gfxp high enough?
      jb 1b
      popl %%edi
      popl %%eax
     ":"=S"(virtual):"0"(virtual),"b"(rainbow),"d"(phase),
        "D"(&GFX(0,y,ziel)),"c"(&GFX(size,y,ziel))
    );
  }; // Das war der entscheidende Schritt zur reellen Geschwindigkeit!
}
else
{ register int x;
  register int y;
  register int y2;
  err_exit("Plasma - Tried to be fast, but data size was wrong\n");
  for (y=0, y2=0; y<size; y++)
  { for (x=0; x<size; x++, y2++)
    { GFX( x , y , ziel ) =
      rainbow[ 255 & ( phase + virtual[y2] ) ];
     };
   }; // Das war der entscheidende Schritt zur virtuellen Palettenanimation!
};

}; // NICHT inline, da sonst nicht genug reg-vars verfuegbar sind!

#else

void virt2gfx(int phase, int size, int * virtual, \
 EA_PIXEL * ziel, EA_PIXEL * rainbow )
// Virtuellen 8bpp Schirm anzeigen - ZEITKRITISCH
{ register int x;
  register int y;
  register int y2;
  for (y=0, y2=0; y<size; y++)
  { for (x=0; x<size; x++, y2++)
    { GFX( x , y , ziel ) =
      rainbow[ 255 & ( phase + virtual[y2] ) ];
     };
   }; // Das war der entscheidende Schritt zur virtuellen Palettenanimation!
}; // NICHT inline, da sonst nicht genug reg-vars verfuegbar sind!

#endif
