#include "starfield_3d.h"

/* Starfield using simple 3D, AuerSoft 22.6.97, X11 Version 3/2000     */
/* DOS Version war 8.8 Festkomma und zbuf und colbuf waren 1 Feld =8-| */
/* Starmaker bestimmt die x/y Koords bei maximaler Annaeherung,        */
/* die deutlich ausserhalb des Fensters liegen koennen (!).            */
/* Spaeter wird x/y dann mit 1/z gezoomt und z geht als loop downto 1  */
// round2int(a) siehe typen.h -> ((int)rint(a))
// jetzt auch als Assembler: round2int_inline(intvalue,floatvalue) 8-)

void star_step(int first, int xsize, int ysize, EA_PIXEL * dest)
{ const maxdepth = 100;
  const mediumdist = 66;
  const smalldist = 33;
 static int xbuf[STARS]; 
 static int ybuf[STARS]; 
 static int   zbuf[STARS];
 static EA_PIXEL colbuf[STARS];
 static EA_PIXEL * st_dest;
 static EA_PIXEL starpal[ST_COLORS];
 static int xhalf, yhalf, xmax, ymax;
 int cnt, cc;
 int x, y, z; 
 float zinv; 
 EA_PIXEL c; 
 static EA_PIXEL bgcolor;
 static EA_PIXEL color_msb;

#define STARMAKER(id) { zbuf[id] = maxdepth; \
 colbuf[id] = starpal[rnd(0, ST_COLORS-1)]; \
 xbuf[id] = rnd(-(xhalf<<7), xhalf<<7); \
 ybuf[id] = rnd(-(yhalf<<7), yhalf<<7); \
 if ( (abs(xbuf[id]) < 1) || (abs(ybuf[id]) < 1) ) zbuf[id]=0; }

#define BIGPIX(col) { GFX(x, y, st_dest)=col; GFX(x+1, y, st_dest)=col; \
 GFX(x, y+1, st_dest)=col; GFX(x+1, y+1, st_dest)=col; }

if (first == 1) 
{ xhalf = xsize >> 1;
  xmax = xsize - 2; /* wg BIGPIX */
  yhalf = ysize >> 1;
  ymax = ysize - 2; /* wg BIGPIX */
  for (cnt=0; cnt<STARS; cnt++) 
  { STARMAKER(cnt); 
    /* Zuerst sollen nicht alle Sterne gleich fern sein, also: */
    zbuf[cnt] = rnd(1, maxdepth);
  };
  for (cnt=0; cnt < (ST_COLORS-3); cnt += 4) 
  { cc = rnd(64,127); // max 50% Helligkeit wg. Trick ...
    starpal[cnt] = RGB(cc, cc, cc);          // Graustufe
    starpal[cnt+1] = RGB(cc, cc, 0);         // Gelbton
    starpal[cnt+2] = RGB(cc>>1, cc>>1, 127); // Strahleblau
    starpal[cnt+2] = RGB(cc, cc>>1, cc>>1);  // Blassrot
  };
  st_dest=dest; 
  bgcolor = RGB(0, 0, 0);
  color_msb = RGB(128, 128, 128);
  for (y=0; y<ysize; y++)
  { for (x=0; x<xsize; x++) { GFX(x, y, st_dest) = bgcolor; };
  }; /* alles auf bgcolor setzen! */
};

if (first == 0) 
{ x = 0; y = 0;
  for (cnt=0; cnt<STARS; cnt++)
  { z = zbuf[cnt]; 
    if (z > 0)
    { zinv = 1.0 / z;
      round2int_inline( x , zinv * xbuf[cnt] ); x += xhalf;
      round2int_inline( y , zinv * ybuf[cnt] ); y += yhalf;
//    x = xhalf + round2int( zinv * xbuf[cnt] );
//    y = yhalf + round2int( zinv * ybuf[cnt] );
      if ((x < 0) || (y < 0) || \
          (x >= xmax) || (y >= ymax) )
      { /* clipping - out of range */ }
      else
      { if (z >= smalldist) 
        { GFX(x, y, st_dest) = bgcolor; 
        } else { BIGPIX(bgcolor); };
      };
      z--; 
      zbuf[cnt] = z; 
    };
    if (z > 0) { zinv = 1.0 / z;
                 round2int_inline( x , zinv * xbuf[cnt] ); x += xhalf; 
                 round2int_inline( y , zinv * ybuf[cnt] ); y += yhalf; 
//               x = xhalf + round2int( zinv * xbuf[cnt] );
//               y = yhalf + round2int( zinv * ybuf[cnt] );
               };
    if ((z < 1) || (x < 0) || (y < 0) || \
        (x >= xmax) || (y >= ymax) ) 
    { STARMAKER(cnt); /* diesmal ist z-Wert ok... */ }
    else 
    { c = colbuf[cnt];
      if ( (z < mediumdist) && (!(c & color_msb)) )
      { c <<= 1; colbuf[cnt] = c; };
      // bei mittlerer Entfernung Helligkeit maximal hochshiften!
      if (z >= smalldist) 
      { GFX(x, y, st_dest) = c; // Kleines Pixel...
      } else { BIGPIX(c); };    // ... oder grosses Pixel!
    };
  };
};

if (first == -1) 
{ for (cnt=0; cnt<STARS; cnt++) // hide all stars
  { z = zbuf[cnt]; 
    if (z > 0)
    { zinv = 1.0 / z;
      round2int_inline( x , zinv * xbuf[cnt] ); x += xhalf; 
      round2int_inline( y , zinv * ybuf[cnt] ); y += yhalf;
//    x = xhalf + round2int( zinv * xbuf[cnt] );
//    y = yhalf + round2int( zinv * ybuf[cnt] );
      if ((x < 0) || (y < 0) || \
          (x >= xmax) || (y >= ymax) )
      { /* clipping - out of range */ }
      else
      { if (z >= smalldist) 
        { GFX(x, y, st_dest)=bgcolor; 
        } else { BIGPIX(bgcolor); };
      };
    };
  };
};

};
